require "util"

script.on_event(defines.events, function(event)
	-- on_tick
	if event.name == defines.events.on_tick then
		for playerIndex, player in pairs(game.players) do
			-- decrease
			if player.gui.top.decrease == nil then
				player.gui.top.add{name = "decrease", type = "button", caption = "<", style="fentus-button"}
			end
			
			-- decrease1
			if player.gui.top.decrease1 == nil then
				player.gui.top.add{name = "decrease1", type = "button", caption = "<<", style="fentus-button"}
			end
			
			-- speed
			if player.gui.top.display == nil then
				player.gui.top.add{name = "display", type = "label", caption = "Speed "..tostring(format_num(game.speed,2,"x","")), style="caption_label_style"}
			end
	
			-- increase1
			if player.gui.top.increase1 == nil then
				player.gui.top.add{name = "increase1", type = "button", caption = ">>", style="fentus-button"}
			end
	
			-- increase
			if player.gui.top.increase == nil then
				player.gui.top.add{name = "increase", type = "button", caption = ">", style="fentus-button"}
			end
		end
	end
	
	-- on_gui_click
	if event.name == defines.events.on_gui_click then
		
		-- decrease
		if event.element.name == "decrease" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.decrease then
					game.speed = math.clamp(game.speed - 0.1, 0.1, 25)
					player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
					break
				end
			end
		end
		
		-- decrease1
		if event.element.name == "decrease1" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.decrease1 then
					game.speed = math.clamp(game.speed - 1, 0.1, 25)
					player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
					break
				end
			end
		end
		
		-- increase1
		if event.element.name == "increase1" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.increase1 then
					game.speed = math.clamp(game.speed + 1, 0.1, 25)
					player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
					break
				end
			end
		end
		
		-- increase
		if event.element.name == "increase" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.increase then
					game.speed = math.clamp(game.speed + 0.1, 0.1, 25)
					player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
					break
				end
			end
		end
	end
end)

function format_num(amount, decimal, prefix, neg_prefix)
  local str_amount,  formatted, famount, remain

  decimal = decimal or 2 -- default 2 decimal places
  neg_prefix = neg_prefix or "-" -- default negative sign

  famount = math.abs(round(amount,decimal))
  famount = math.floor(famount)

  remain = round(math.abs(amount) - famount, decimal)

  -- comma to separate the thousands
  formatted = comma_value(famount)

  -- attach the decimal portion
  if (decimal > 0) then
    remain = string.sub(tostring(remain),3)
    formatted = formatted .. "." .. remain ..
                string.rep("0", decimal - string.len(remain))
  end

  -- attach prefix string e.g '$' 
  formatted = (prefix or "") .. formatted 

  -- if value is negative then format accordingly
  if (amount<0) then
    if (neg_prefix=="()") then
      formatted = "("..formatted ..")"
    else
      formatted = neg_prefix .. formatted 
    end
  end

  return formatted
end

function round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

function math.clamp(val, lower, upper)
    if lower > upper then
		lower, upper = upper, lower
	end
	
    return math.max(lower, math.min(upper, val))
end